## wabt 1.0.6

=== CMakeLists.txt ===
#
# Copyright 2016 WebAssembly Community Group participants
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

cmake_minimum_required(VERSION 2.6)
project(WABT)

option(BUILD_TESTS "Build GTest-based tests" ON)
option(BUILD_TOOLS "Build wabt commandline tools" ON)
option(RUN_RE2C "Run re2c" ON)
option(USE_ASAN "Use address sanitizer" OFF)
option(USE_MSAN "Use memory sanitizer" OFF)
option(USE_LSAN "Use leak sanitizer" OFF)
option(USE_UBSAN "Use undefined behavior sanitizer" OFF)
option(CODE_COVERAGE "Build with code coverage enabled" OFF)
option(WITH_EXCEPTIONS "Build with exceptions enabled" OFF)

if (${CMAKE_C_COMPILER_ID} STREQUAL "Clang")
  set(COMPILER_IS_CLANG 1)
  set(COMPILER_IS_GNU 0)
  set(COMPILER_IS_MSVC 0)
elseif (${CMAKE_C_COMPILER_ID} STREQUAL "GNU")
  set(COMPILER_IS_CLANG 0)
  set(COMPILER_IS_GNU 1)
  set(COMPILER_IS_MSVC 0)
elseif (${CMAKE_C_COMPILER_ID} STREQUAL "MSVC")
  set(COMPILER_IS_CLANG 0)
  set(COMPILER_IS_GNU 0)
  set(COMPILER_IS_MSVC 1)
elseif (${CMAKE_SYSTEM_NAME} STREQUAL "Emscripten")
  set(COMPILER_IS_CLANG 1)
  set(COMPILER_IS_GNU 0)
  set(COMPILER_IS_MSVC 0)
else ()
  set(COMPILER_IS_CLANG 0)
  set(COMPILER_IS_GNU 0)
  set(COMPILER_IS_MSVC 0)
endif ()

include(CheckIncludeFile)
include(CheckSymbolExists)

check_include_file("alloca.h" HAVE_ALLOCA_H)
check_include_file("unistd.h" HAVE_UNISTD_H)
check_symbol_exists(snprintf "stdio.h" HAVE_SNPRINTF)
check_symbol_exists(sysconf "unistd.h" HAVE_SYSCONF)
check_symbol_exists(strcasecmp "strings.h" HAVE_STRCASECMP)

if (WIN32)
  check_symbol_exists(ENABLE_VIRTUAL_TERMINAL_PROCESSING "windows.h" HAVE_WIN32_VT100)
endif ()

include(CheckTypeSize)
check_type_size(ssize_t SSIZE_T)
check_type_size(size_t SIZEOF_SIZE_T)

configure_file(
  ${WABT_SOURCE_DIR}/src/config.h.in
  ${WABT_BINARY_DIR}/config.h
)

include_directories(${WABT_SOURCE_DIR} ${WABT_BINARY_DIR})

if (COMPILER_IS_MSVC)
  # disable warning C4018: signed/unsigned mismatch
  # disable warning C4056, C4756: overflow in floating-point constant arithmetic
  #   seems to not like float compare w/ HUGE_VALF; bug?
  # disable warnings C4267 and C4244: conversion/truncation from larger to smaller type.
  # disable warning C4800: implicit conversion from larger int to bool
  add_definitions(-W3 -wd4018 -wd4056 -wd4756 -wd4267 -wd4244 -wd4800 -WX -D_CRT_SECURE_NO_WARNINGS -D_SCL_SECURE_NO_WARNINGS)

  if (NOT WITH_EXCEPTIONS)
    # disable exception use in C++ library
    add_definitions(-D_HAS_EXCEPTIONS=0)
  endif ()
else ()
  # disable -Wunused-parameter: this is really common when implementing
  #   interfaces, etc.
  # disable -Wpointer-arith: this is a GCC extension, and doesn't work in MSVC.
  add_definitions(
    -Wall -Wextra -Werror -Wno-unused-parameter -Wpointer-arith -g
    -Wuninitialized
  )

  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Wold-style-cast")

  if (NOT WITH_EXCEPTIONS)
    add_definitions(-fno-exceptions)
  endif ()

  # Need to define __STDC_*_MACROS because C99 specifies that C++ shouldn't
  # define format (e.g. PRIu64) or limit (e.g. UINT32_MAX) macros without the
  # definition, and some libcs (e.g. glibc2.17 and earlier) follow that.
  add_definitions(-D__STDC_LIMIT_MACROS=1 -D__STDC_FORMAT_MACROS=1)

  if (MINGW)
    # _POSIX is needed to ensure we use mingw printf
    # instead of the VC runtime one.
    add_definitions(-D_POSIX)
  endif ()

  if (COMPILER_IS_GNU)
    # disable -Wclobbered: it seems to be guessing incorrectly about a local
    # variable being clobbered by longjmp.
    add_definitions(-Wno-clobbered)
  endif ()

  if (NOT EMSCRIPTEN)
    # try to get the target architecture by compiling a dummy.c file and
    # checking the architecture using the file command.
    file(WRITE ${WABT_BINARY_DIR}/dummy.c "main(){}")
    try_compile(
      COMPILE_OK
      ${WABT_BINARY_DIR}
      ${WABT_BINARY_DIR}/dummy.c
      COPY_FILE ${WABT_BINARY_DIR}/dummy
    )
    if (COMPILE_OK)
      execute_process(
        COMMAND file ${WABT_BINARY_DIR}/dummy
        RESULT_VARIABLE FILE_RESULT
        OUTPUT_VARIABLE FILE_OUTPUT
        ERROR_QUIET
      )

      if (FILE_RESULT EQUAL 0)
        if (${FILE_OUTPUT} MATCHES "x86[-_]64")
          set(TARGET_ARCH "x86-64")
        elseif (${FILE_OUTPUT} MATCHES "Intel 80386")
          set(TARGET_ARCH "i386")
        elseif (${FILE_OUTPUT} MATCHES "ARM")
          set(TARGET_ARCH "ARM")
        else ()
          message(WARNING "Unknown target architecture!")
        endif ()
      else ()
        message(WARNING "Error running file on dummy executable")
      endif ()
    else ()
      message(WARNING "Error compiling dummy.c file")
    endif ()

    if (TARGET_ARCH STREQUAL "i386")
      # wasm doesn't allow for x87 floating point math
      add_definitions(-msse2 -mfpmath=sse)
    endif ()
  endif ()
endif ()

set(USE_SANITIZER FALSE)

function(SANITIZER NAME FLAGS)
  if (${NAME})
    if (USE_SANITIZER)
      message(FATAL_ERROR "Only one sanitizer allowed")
    endif ()
    set(USE_SANITIZER TRUE PARENT_SCOPE)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${FLAGS}" PARENT_SCOPE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${FLAGS}" PARENT_SCOPE)
  endif ()
endfunction()
SANITIZER(USE_ASAN "-fsanitize=address")
SANITIZER(USE_MSAN "-fsanitize=memory")
SANITIZER(USE_LSAN "-fsanitize=leak")

if (USE_UBSAN)
  # -fno-sanitize-recover was deprecated, see if we are compiling with a newer
  # clang that requires -fno-sanitize-recover=all.
  set(UBSAN_BLACKLIST ${WABT_SOURCE_DIR}/ubsan.blacklist)
  include(CheckCXXCompilerFlag)
  CHECK_CXX_COMPILER_FLAG("-fsanitize=undefined -fno-sanitize-recover -Wall -Werror" HAS_UBSAN_RECOVER_BARE)
  if (HAS_UBSAN_RECOVER_BARE)
    SANITIZER(USE_UBSAN "-fsanitize=undefined -fno-sanitize-recover -fsanitize-blacklist=${UBSAN_BLACKLIST}")
  endif ()
  CHECK_CXX_COMPILER_FLAG("-fsanitize=undefined -fno-sanitize-recover=all -Wall -Werror" HAS_UBSAN_RECOVER_ALL)
  if (HAS_UBSAN_RECOVER_ALL)
    SANITIZER(USE_UBSAN "-fsanitize=undefined -fno-sanitize-recover=all -fsanitize-blacklist=${UBSAN_BLACKLIST}")
  endif ()
  if (NOT USE_SANITIZER)
    message(FATAL_ERROR "UBSAN is not supported")
  endif ()
endif ()

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${WABT_SOURCE_DIR}/cmake)
find_package(RE2C)
if (RUN_RE2C AND RE2C_EXECUTABLE AND (NOT ${RE2C_VERSION} VERSION_LESS "0.16"))
  message(STATUS "Using generated re2c lexer")
  set(WAST_LEXER_CC ${WABT_SOURCE_DIR}/src/wast-lexer.cc)
  set(WAST_LEXER_GEN_CC ${WABT_BINARY_DIR}/wast-lexer-gen.cc)
  RE2C_TARGET(
    NAME WAST_LEXER_GEN_CC
    INPUT ${WAST_LEXER_CC}
    OUTPUT ${WAST_LEXER_GEN_CC}
    OPTIONS -bc8 -W -Werror
  )
else ()
  message(STATUS "Using prebuilt re2c lexer")
  set(WAST_LEXER_GEN_CC src/prebuilt/wast-lexer-gen.cc)
endif ()

add_custom_target(everything)

add_library(wabt STATIC
  src/apply-names.cc
  src/binary.cc
  src/binary-reader.cc
  src/binary-reader-ir.cc
  src/binary-reader-logging.cc
  src/binary-writer.cc
  src/binary-writer-spec.cc
  src/binding-hash.cc
  src/color.cc
  src/common.cc
  src/config.cc
  src/error-formatter.cc
  src/expr-visitor.cc
  src/feature.cc
  src/filenames.cc
  src/generate-names.cc
  src/hash-util.cc
  src/ir.cc
  src/leb128.cc
  src/lexer-source.cc
  src/lexer-source-line-finder.cc
  src/literal.cc
  src/opcode.cc
  src/opcode-code-table.c
  src/option-parser.cc
  src/resolve-names.cc
  src/stream.cc
  src/string-view.cc
  src/token.cc
  src/tracing.cc
  src/type-checker.cc
  src/utf8.cc
  src/validator.cc
  src/wast-parser.cc
  src/wat-writer.cc
  ${WAST_LEXER_GEN_CC}

  # TODO(binji): Move this into its own library?
  src/interp/binary-reader-interp.cc
  src/interp/interp.cc
  src/interp/interp-disassemble.cc
  src/interp/interp-trace.cc
)


if (NOT EMSCRIPTEN)
  if (CODE_COVERAGE)
    add_definitions("-fprofile-arcs -ftest-coverage")
    if (COMPILER_IS_CLANG)
      set(CMAKE_EXE_LINKER_FLAGS "--coverage")
    else ()
      link_libraries(gcov)
    endif ()
  endif ()

  function(wabt_executable)
    cmake_parse_arguments(EXE "WITH_LIBM;INSTALL" "NAME" "SOURCES;LIBS" ${ARGN})

    # Always link libwabt.
    set(EXE_LIBS "${EXE_LIBS};wabt")

    # Optionally link libm.
    if (EXE_WITH_LIBM AND (COMPILER_IS_CLANG OR COMPILER_IS_GNU))
      set(EXE_LIBS "${EXE_LIBS};m")
    endif ()

    add_executable(${EXE_NAME} ${EXE_SOURCES})
    add_dependencies(everything ${EXE_NAME})
    target_link_libraries(${EXE_NAME} ${EXE_LIBS})
    set_property(TARGET ${EXE_NAME} PROPERTY CXX_STANDARD 11)
    set_property(TARGET ${EXE_NAME} PROPERTY CXX_STANDARD_REQUIRED ON)

    if (EXE_INSTALL)
      list(APPEND WABT_EXECUTABLES ${EXE_NAME})
      set(WABT_EXECUTABLES ${WABT_EXECUTABLES} PARENT_SCOPE)

      add_custom_target(${EXE_NAME}-copy-to-bin ALL
        COMMAND ${CMAKE_COMMAND} -E make_directory ${WABT_SOURCE_DIR}/bin
        COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_FILE:${EXE_NAME}> ${WABT_SOURCE_DIR}/bin
        DEPENDS ${EXE_NAME}
      )
    endif ()
  endfunction()

  if (BUILD_TOOLS)
    # wat2wasm
    wabt_executable(
      NAME wat2wasm
      SOURCES src/tools/wat2wasm.cc
      INSTALL
    )

    # wast2json
    wabt_executable(
      NAME wast2json
      SOURCES src/tools/wast2json.cc
      INSTALL
    )

    # wasm2wat
    wabt_executable(
      NAME wasm2wat
      SOURCES src/tools/wasm2wat.cc
      INSTALL
    )

    # wasm2c
    wabt_executable(
      NAME wasm2c
      SOURCES src/tools/wasm2c.cc src/c-writer.cc
      INSTALL
    )

    # wasm-opcodecnt
    wabt_executable(
      NAME wasm-opcodecnt
      SOURCES src/tools/wasm-opcodecnt.cc src/binary-reader-opcnt.cc
      INSTALL
    )

    # wasm-objdump
    wabt_executable(
      NAME wasm-objdump
      SOURCES src/tools/wasm-objdump.cc src/binary-reader-objdump.cc
      INSTALL
    )

    # wasm-interp
    wabt_executable(
      NAME wasm-interp
      SOURCES src/tools/wasm-interp.cc
      WITH_LIBM
      INSTALL
    )

    # spectest-interp
    wabt_executable(
      NAME spectest-interp
      SOURCES src/tools/spectest-interp.cc
      WITH_LIBM
      INSTALL
    )

    # wat-desugar
    wabt_executable(
      NAME wat-desugar
      SOURCES src/tools/wat-desugar.cc
      INSTALL
    )

    # wasm-validate
    wabt_executable(
      NAME wasm-validate
      SOURCES src/tools/wasm-validate.cc
      INSTALL
    )

    # wasm-strip
    wabt_executable(
      NAME wasm-strip
      SOURCES src/tools/wasm-strip.cc
      INSTALL
    )
  endif ()

  find_package(Threads)
  if (BUILD_TESTS)
    if (NOT EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/third_party/gtest/googletest)
      message(FATAL_ERROR "Can't find third_party/gtest. Run git submodule update --init, or disable with CMake -DBUILD_TESTS=OFF.")
    endif ()

    include_directories(
      third_party/gtest/googletest
      third_party/gtest/googletest/include
    )

    # gtest
    add_library(libgtest STATIC
      third_party/gtest/googletest/src/gtest-all.cc
    )

    # hexfloat-test
    set(HEXFLOAT_TEST_SRCS
      src/literal.cc
      src/test-hexfloat.cc
      third_party/gtest/googletest/src/gtest_main.cc
    )
    wabt_executable(
      NAME hexfloat_test
      SOURCES ${HEXFLOAT_TEST_SRCS}
      LIBS libgtest ${CMAKE_THREAD_LIBS_INIT}
    )

    # wabt-unittests
    set(UNITTESTS_SRCS
      src/test-circular-array.cc
      src/test-interp.cc
      src/test-intrusive-list.cc
      src/test-literal.cc
      src/test-string-view.cc
      src/test-filenames.cc
      src/test-utf8.cc
      src/test-wast-parser.cc

=== debian/changelog ===
wabt (1.0.6-1) unstable; urgency=medium

  * Initial release. (Closes: #916611)

 -- Markus Koschany <apo@debian.org>  Mon, 17 Dec 2018 22:18:24 +0100

=== debian/control ===
Source: wabt
Section: devel
Priority: optional
Maintainer: Markus Koschany <apo@debian.org>
Build-Depends:
 cmake,
 debhelper (>= 11),
 python,
 re2c
Standards-Version: 4.2.1
Homepage: https://github.com/WebAssembly/wabt
Vcs-Git: https://salsa.debian.org/debian/wabt.git
Vcs-Browser: https://salsa.debian.org/debian/wabt

Package: wabt
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: WebAssembly Binary Toolkit
 WABT (pronounced: "wabbit") is a suite of tools for WebAssembly, including:
 .
  * wat2wasm: translate from WebAssembly text format to the WebAssembly binary
    format
  * wasm2wat: the inverse of wat2wasm, translate from the binary format back
    to the text format (also known as a .wat)
  * wasm-objdump: print information about a wasm binary. Similar to objdump.
  * wasm-interp: decode and run a WebAssembly binary file using a stack-based
    interpreter
  * wat-desugar: parse .wat text form as supported by the spec interpreter
    (s-expressions, flat syntax, or mixed) and print "canonical" flat format
  * wasm2c: convert a WebAssembly binary file to a C source and header
 .
 These tools are intended for use in (or for development of) toolchains or
 other systems that want to manipulate WebAssembly files. Unlike the
 WebAssembly spec interpreter (which is written to be as simple, declarative
 and "speccy" as possible), they are written in C/C++ and designed for easier
 integration into other systems. Unlike Binaryen these tools do not aim to
 provide an optimization platform or a higher-level compiler target; instead
 they aim for full fidelity and compliance with the spec (e.g. 1:1 round-trips
 with no changes to instructions).

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/privacybadger-$1\.tar\.gz/ \
  https://github.com/WebAssembly/wabt/tags .*/v?(\d\S+)\.tar\.gz

## wabt 1.0.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -26,6 +26,7 @@
 option(USE_UBSAN "Use undefined behavior sanitizer" OFF)
 option(CODE_COVERAGE "Build with code coverage enabled" OFF)
 option(WITH_EXCEPTIONS "Build with exceptions enabled" OFF)
+option(WERROR "Build with warnings as errors" OFF)
 
 if (${CMAKE_C_COMPILER_ID} STREQUAL "Clang")
   set(COMPILER_IS_CLANG 1)
@@ -79,7 +80,11 @@
   #   seems to not like float compare w/ HUGE_VALF; bug?
   # disable warnings C4267 and C4244: conversion/truncation from larger to smaller type.
   # disable warning C4800: implicit conversion from larger int to bool
-  add_definitions(-W3 -wd4018 -wd4056 -wd4756 -wd4267 -wd4244 -wd4800 -WX -D_CRT_SECURE_NO_WARNINGS -D_SCL_SECURE_NO_WARNINGS)
+  add_definitions(-W3 -wd4018 -wd4056 -wd4756 -wd4267 -wd4244 -wd4800 -D_CRT_SECURE_NO_WARNINGS -D_SCL_SECURE_NO_WARNINGS)
+
+  if (WERROR)
+    add_definitions(-WX)
+  endif ()
 
   if (NOT WITH_EXCEPTIONS)
     # disable exception use in C++ library
@@ -90,11 +95,15 @@
   #   interfaces, etc.
   # disable -Wpointer-arith: this is a GCC extension, and doesn't work in MSVC.
   add_definitions(
-    -Wall -Wextra -Werror -Wno-unused-parameter -Wpointer-arith -g
+    -Wall -Wextra -Wno-unused-parameter -Wpointer-arith -g
     -Wuninitialized
   )
 
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Wold-style-cast")
+
+  if (WERROR)
+    add_definitions(-Werror)
+  endif ()
 
   if (NOT WITH_EXCEPTIONS)
     add_definitions(-fno-exceptions)
@@ -408,11 +417,6 @@
 
     # wabt-unittests
     set(UNITTESTS_SRCS
+      src/test-binary-reader.cc
       src/test-circular-array.cc
       src/test-interp.cc
-      src/test-intrusive-list.cc
-      src/test-literal.cc
-      src/test-string-view.cc
-      src/test-filenames.cc
-      src/test-utf8.cc
-      src/test-wast-parser.cc

=== Makefile ===
#
# Copyright 2016 WebAssembly Community Group participants
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

.SUFFIXES:

MAKEFILE_NAME := $(lastword $(MAKEFILE_LIST))
ROOT_DIR := $(dir $(abspath $(MAKEFILE_NAME)))

USE_NINJA ?= 0
FUZZ_BIN_DIR ?= ${ROOT_DIR}/afl-fuzz
GCC_FUZZ_CC := ${FUZZ_BIN_DIR}/afl-gcc
GCC_FUZZ_CXX := ${FUZZ_BIN_DIR}/afl-g++
EMSCRIPTEN_DIR ?= ${ROOT_DIR}/emscripten
CMAKE_CMD ?= cmake

DEFAULT_SUFFIX = clang-debug

COMPILERS := GCC GCC_I686 GCC_FUZZ CLANG EMCC
BUILD_TYPES := DEBUG RELEASE
SANITIZERS := ASAN MSAN LSAN UBSAN
CONFIGS := NORMAL $(SANITIZERS) COV NO_RE2C NO_TESTS

# directory names
GCC_DIR := gcc/
GCC_I686_DIR := gcc-i686/
GCC_FUZZ_DIR := gcc-fuzz/
CLANG_DIR := clang/
EMCC_DIR := emscripten/
DEBUG_DIR := Debug/
RELEASE_DIR := Release/
NORMAL_DIR :=
ASAN_DIR := asan/
MSAN_DIR := msan/
LSAN_DIR := lsan/
UBSAN_DIR := ubsan/
NO_RE2C_DIR := no-re2c/
COV_DIR := cov/
NO_TESTS_DIR := no-tests/

# CMake flags
GCC_FLAG := -DCMAKE_C_COMPILER=gcc -DCMAKE_CXX_COMPILER=g++
GCC_I686_FLAG := -DCMAKE_C_COMPILER=gcc -DCMAKE_CXX_COMPILER=g++ \
	-DCMAKE_C_FLAGS=-m32 -DCMAKE_CXX_FLAGS=-m32
GCC_FUZZ_FLAG := -DCMAKE_C_COMPILER=${GCC_FUZZ_CC} -DCMAKE_CXX_COMPILER=${GCC_FUZZ_CXX} -DWITH_EXCEPTIONS=ON
CLANG_FLAG := -DCMAKE_C_COMPILER=clang -DCMAKE_CXX_COMPILER=clang++
EMCC_FLAG := -DCMAKE_TOOLCHAIN_FILE=${EMSCRIPTEN_DIR}/cmake/Modules/Platform/Emscripten.cmake
DEBUG_FLAG := -DCMAKE_BUILD_TYPE=Debug
RELEASE_FLAG := -DCMAKE_BUILD_TYPE=Release
NORMAL_FLAG :=
ASAN_FLAG := -DUSE_ASAN=ON
MSAN_FLAG := -DUSE_MSAN=ON
LSAN_FLAG := -DUSE_LSAN=ON
UBSAN_FLAG := -DUSE_UBSAN=ON
COV_FLAG := -DCODE_COVERAGE=ON
NO_RE2C_FLAG := -DRUN_RE2C=OFF
NO_TESTS_FLAG := -DBUILD_TESTS=OFF

# make target prefixes
GCC_PREFIX := gcc
GCC_I686_PREFIX := gcc-i686
GCC_FUZZ_PREFIX := gcc-fuzz
CLANG_PREFIX := clang
EMCC_PREFIX := emscripten
DEBUG_PREFIX := -debug
RELEASE_PREFIX := -release
NORMAL_PREFIX :=
ASAN_PREFIX := -asan
MSAN_PREFIX := -msan
LSAN_PREFIX := -lsan
UBSAN_PREFIX := -ubsan
COV_PREFIX := -cov
NO_RE2C_PREFIX := -no-re2c
NO_TESTS_PREFIX := -no-tests

ifeq ($(USE_NINJA),1)
BUILD_CMD := ninja
BUILD_FILE := build.ninja
GENERATOR := Ninja
else
BUILD_CMD := +$(MAKE) --no-print-directory
BUILD_FILE := Makefile
GENERATOR := "Unix Makefiles"
endif

CMAKE_DIR = out/$($(1)_DIR)$($(2)_DIR)$($(3)_DIR)
BUILD_TARGET = $($(1)_PREFIX)$($(2)_PREFIX)$($(3)_PREFIX)
INSTALL_TARGET = install-$($(1)_PREFIX)$($(2)_PREFIX)$($(3)_PREFIX)
TEST_TARGET = test-$($(1)_PREFIX)$($(2)_PREFIX)$($(3)_PREFIX)

define CMAKE
$(call CMAKE_DIR,$(1),$(2),$(3)):
	mkdir -p $(call CMAKE_DIR,$(1),$(2),$(3))

$(call CMAKE_DIR,$(1),$(2),$(3))$$(BUILD_FILE): | $(call CMAKE_DIR,$(1),$(2),$(3))
	cd $(call CMAKE_DIR,$(1),$(2),$(3)) && \
	$$(CMAKE_CMD) -G $$(GENERATOR) $$(ROOT_DIR) $$($(1)_FLAG) $$($(2)_FLAG) $$($(3)_FLAG)
endef

define BUILD
.PHONY: $(call BUILD_TARGET,$(1),$(2),$(3))
$(call BUILD_TARGET,$(1),$(2),$(3)): $(call CMAKE_DIR,$(1),$(2),$(3))$$(BUILD_FILE)
	$$(BUILD_CMD) -C $(call CMAKE_DIR,$(1),$(2),$(3)) all
endef

define INSTALL
.PHONY: $(call INSTALL_TARGET,$(1),$(2),$(3))
$(call INSTALL_TARGET,$(1),$(2),$(3)): $(call CMAKE_DIR,$(1),$(2),$(3))$$(BUILD_FILE)
	$$(BUILD_CMD) -C $(call CMAKE_DIR,$(1),$(2),$(3)) install
endef

define TEST
.PHONY: $(call TEST_TARGET,$(1),$(2),$(3))
$(call TEST_TARGET,$(1),$(2),$(3)): $(call CMAKE_DIR,$(1),$(2),$(3))$$(BUILD_FILE)
	$$(BUILD_CMD) -C $(call CMAKE_DIR,$(1),$(2),$(3)) run-tests
test-everything: $(CALL TEST_TARGET,$(1),$(2),$(3))
endef

.PHONY: all install test
all: $(DEFAULT_SUFFIX)
install: install-$(DEFAULT_SUFFIX)
test: test-$(DEFAULT_SUFFIX)

.PHONY: clean
clean:
	rm -rf out

.PHONY: test-everything
test-everything:

.PHONY: update-re2c
update-re2c: src/prebuilt/wast-lexer-gen.cc

src/prebuilt/wast-lexer-gen.cc: src/wast-lexer.cc
	re2c -W -Werror --no-generation-date -bc8 -o $@ $<

.PHONY: update-wasm2c
update-wasm2c: src/prebuilt/wasm2c.include.c src/prebuilt/wasm2c.include.h

src/prebuilt/wasm2c.include.c: src/wasm2c.c.tmpl
	src/wasm2c_tmpl.py -o $@ $<

src/prebuilt/wasm2c.include.h: src/wasm2c.h.tmpl
	src/wasm2c_tmpl.py -o $@ $<

.PHONY: demo
demo: emscripten-release
	cp out/emscripten/Release/libwabt.js demo

# running CMake
$(foreach CONFIG,$(CONFIGS), \
	$(foreach COMPILER,$(COMPILERS), \
		$(foreach BUILD_TYPE,$(BUILD_TYPES), \
			$(eval $(call CMAKE,$(COMPILER),$(BUILD_TYPE),$(CONFIG))))))

# building
$(foreach CONFIG,$(CONFIGS), \
	$(foreach COMPILER,$(COMPILERS), \
		$(foreach BUILD_TYPE,$(BUILD_TYPES), \
			$(eval $(call BUILD,$(COMPILER),$(BUILD_TYPE),$(CONFIG))))))

# installing
$(foreach CONFIG,$(CONFIGS), \
	$(foreach COMPILER,$(COMPILERS), \
		$(foreach BUILD_TYPE,$(BUILD_TYPES), \
			$(eval $(call INSTALL,$(COMPILER),$(BUILD_TYPE),$(CONFIG))))))

# test running
$(foreach CONFIG,$(CONFIGS), \
	$(foreach COMPILER,$(COMPILERS), \
		$(foreach BUILD_TYPE,$(BUILD_TYPES), \
			$(eval $(call TEST,$(COMPILER),$(BUILD_TYPE),$(CONFIG))))))

=== debian/changelog ===
wabt (1.0.8-1) unstable; urgency=medium

  * New upstream version 1.0.8.
  * Update d/copyright for new release and remove the demo because it contains
    Javascript files without source and we cannot rebuild libwabt.js without
    Emscripten. The demo is not needed too.
  * Declare compliance with Debian Policy 4.3.0.
  * Switch to compat level 12.

 -- Markus Koschany <apo@debian.org>  Fri, 18 Jan 2019 14:30:00 +0100

=== debian/control ===
--- 
+++ 
@@ -4,10 +4,10 @@
 Maintainer: Markus Koschany <apo@debian.org>
 Build-Depends:
  cmake,
- debhelper (>= 11),
+ debhelper (>= 12),
  python,
  re2c
-Standards-Version: 4.2.1
+Standards-Version: 4.3.0
 Homepage: https://github.com/WebAssembly/wabt
 Vcs-Git: https://salsa.debian.org/debian/wabt.git
 Vcs-Browser: https://salsa.debian.org/debian/wabt

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBUILD_TESTS=OFF

## wabt 1.0.11

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,7 +19,6 @@
 
 option(BUILD_TESTS "Build GTest-based tests" ON)
 option(BUILD_TOOLS "Build wabt commandline tools" ON)
-option(RUN_RE2C "Run re2c" ON)
 option(USE_ASAN "Use address sanitizer" OFF)
 option(USE_MSAN "Use memory sanitizer" OFF)
 option(USE_LSAN "Use leak sanitizer" OFF)
@@ -155,7 +154,7 @@
           message(WARNING "Unknown target architecture!")
         endif ()
       else ()
-        message(WARNING "Error running file on dummy executable")
+        message(WARNING "Error running `file` command on dummy executable")
       endif ()
     else ()
       message(WARNING "Error compiling dummy.c file")
@@ -203,21 +202,6 @@
 endif ()
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${WABT_SOURCE_DIR}/cmake)
-find_package(RE2C)
-if (RUN_RE2C AND RE2C_EXECUTABLE AND (NOT ${RE2C_VERSION} VERSION_LESS "0.16"))
-  message(STATUS "Using generated re2c lexer")
-  set(WAST_LEXER_CC ${WABT_SOURCE_DIR}/src/wast-lexer.cc)
-  set(WAST_LEXER_GEN_CC ${WABT_BINARY_DIR}/wast-lexer-gen.cc)
-  RE2C_TARGET(
-    NAME WAST_LEXER_GEN_CC
-    INPUT ${WAST_LEXER_CC}
-    OUTPUT ${WAST_LEXER_GEN_CC}
-    OPTIONS -bc8 -W -Werror
-  )
-else ()
-  message(STATUS "Using prebuilt re2c lexer")
-  set(WAST_LEXER_GEN_CC src/prebuilt/wast-lexer-gen.cc)
-endif ()
 
 add_custom_target(everything)
 
@@ -255,9 +239,9 @@
   src/type-checker.cc
   src/utf8.cc
   src/validator.cc
+  src/wast-lexer.cc
   src/wast-parser.cc
   src/wat-writer.cc
-  ${WAST_LEXER_GEN_CC}
 
   # TODO(binji): Move this into its own library?
   src/interp/binary-reader-interp.cc
@@ -420,3 +404,23 @@
       src/test-binary-reader.cc
       src/test-circular-array.cc
       src/test-interp.cc
+      src/test-intrusive-list.cc
+      src/test-literal.cc
+      src/test-string-view.cc
+      src/test-filenames.cc
+      src/test-utf8.cc
+      src/test-wast-parser.cc
+      third_party/gtest/googletest/src/gtest_main.cc
+    )
+    wabt_executable(
+      NAME wabt-unittests
+      SOURCES ${UNITTESTS_SRCS}
+      LIBS libgtest ${CMAKE_THREAD_LIBS_INIT}
+    )
+
+    if (NOT CMAKE_VERSION VERSION_LESS "3.2")
+      set(USES_TERMINAL USES_TERMINAL)
+    endif ()
+
+    # test running
+    find_package(PythonInterp 2.7 REQUIRED)

=== Makefile ===
--- 
+++ 
@@ -31,7 +31,7 @@
 COMPILERS := GCC GCC_I686 GCC_FUZZ CLANG EMCC
 BUILD_TYPES := DEBUG RELEASE
 SANITIZERS := ASAN MSAN LSAN UBSAN
-CONFIGS := NORMAL $(SANITIZERS) COV NO_RE2C NO_TESTS
+CONFIGS := NORMAL $(SANITIZERS) COV NO_TESTS
 
 # directory names
 GCC_DIR := gcc/
@@ -46,7 +46,6 @@
 MSAN_DIR := msan/
 LSAN_DIR := lsan/
 UBSAN_DIR := ubsan/
-NO_RE2C_DIR := no-re2c/
 COV_DIR := cov/
 NO_TESTS_DIR := no-tests/
 
@@ -65,7 +64,6 @@
 LSAN_FLAG := -DUSE_LSAN=ON
 UBSAN_FLAG := -DUSE_UBSAN=ON
 COV_FLAG := -DCODE_COVERAGE=ON
-NO_RE2C_FLAG := -DRUN_RE2C=OFF
 NO_TESTS_FLAG := -DBUILD_TESTS=OFF
 
 # make target prefixes
@@ -82,7 +80,6 @@
 LSAN_PREFIX := -lsan
 UBSAN_PREFIX := -ubsan
 COV_PREFIX := -cov
-NO_RE2C_PREFIX := -no-re2c
 NO_TESTS_PREFIX := -no-tests
 
 ifeq ($(USE_NINJA),1)
@@ -140,11 +137,11 @@
 .PHONY: test-everything
 test-everything:
 
-.PHONY: update-re2c
-update-re2c: src/prebuilt/wast-lexer-gen.cc
+.PHONY: update-gperf
+update-gperf: src/prebuilt/lexer-keywords.cc
 
-src/prebuilt/wast-lexer-gen.cc: src/wast-lexer.cc
-	re2c -W -Werror --no-generation-date -bc8 -o $@ $<
+src/prebuilt/lexer-keywords.cc: src/lexer-keywords.txt
+	gperf -m 50 -L C++ -N InWordSet -E -t -c --output-file=$@ $<
 
 .PHONY: update-wasm2c
 update-wasm2c: src/prebuilt/wasm2c.include.c src/prebuilt/wasm2c.include.h

=== debian/changelog ===
wabt (1.0.11-1) unstable; urgency=medium

  * New upstream version 1.0.11.
  * Declare compliance with Debian Policy 4.4.0.
  * Switch to debhelper-compat = 12.
  * Install the complete wasm2c directory as examples to ease further
    development. (Closes: #932007)

 -- Markus Koschany <apo@debian.org>  Sun, 14 Jul 2019 21:50:11 +0200

=== debian/control ===
--- 
+++ 
@@ -4,10 +4,10 @@
 Maintainer: Markus Koschany <apo@debian.org>
 Build-Depends:
  cmake,
- debhelper (>= 12),
+ debhelper-compat (= 12),
  python,
  re2c
-Standards-Version: 4.3.0
+Standards-Version: 4.4.0
 Homepage: https://github.com/WebAssembly/wabt
 Vcs-Git: https://salsa.debian.org/debian/wabt.git
 Vcs-Browser: https://salsa.debian.org/debian/wabt

## wabt 1.0.12

=== CMakeLists.txt ===
--- 
+++ 
@@ -18,6 +18,7 @@
 project(WABT)
 
 option(BUILD_TESTS "Build GTest-based tests" ON)
+option(USE_SYSTEM_GTEST "Use system GTest, instead of building" OFF)
 option(BUILD_TOOLS "Build wabt commandline tools" ON)
 option(USE_ASAN "Use address sanitizer" OFF)
 option(USE_MSAN "Use memory sanitizer" OFF)
@@ -26,20 +27,21 @@
 option(CODE_COVERAGE "Build with code coverage enabled" OFF)
 option(WITH_EXCEPTIONS "Build with exceptions enabled" OFF)
 option(WERROR "Build with warnings as errors" OFF)
-
-if (${CMAKE_C_COMPILER_ID} STREQUAL "Clang")
+option(WIP_TOOLS "Build Work-In-Progress functionality" OFF)
+
+if (CMAKE_C_COMPILER_ID MATCHES "Clang")
   set(COMPILER_IS_CLANG 1)
   set(COMPILER_IS_GNU 0)
   set(COMPILER_IS_MSVC 0)
-elseif (${CMAKE_C_COMPILER_ID} STREQUAL "GNU")
+elseif (CMAKE_C_COMPILER_ID STREQUAL "GNU")
   set(COMPILER_IS_CLANG 0)
   set(COMPILER_IS_GNU 1)
   set(COMPILER_IS_MSVC 0)
-elseif (${CMAKE_C_COMPILER_ID} STREQUAL "MSVC")
+elseif (MSVC)
   set(COMPILER_IS_CLANG 0)
   set(COMPILER_IS_GNU 0)
   set(COMPILER_IS_MSVC 1)
-elseif (${CMAKE_SYSTEM_NAME} STREQUAL "Emscripten")
+elseif (CMAKE_SYSTEM_NAME STREQUAL "Emscripten")
   set(COMPILER_IS_CLANG 1)
   set(COMPILER_IS_GNU 0)
   set(COMPILER_IS_MSVC 0)
@@ -206,45 +208,88 @@
 add_custom_target(everything)
 
 add_library(wabt STATIC
+  src/apply-names.h
   src/apply-names.cc
+  src/binary.h
   src/binary.cc
+  src/binary-reader.h
   src/binary-reader.cc
+  src/binary-reader-ir.h
   src/binary-reader-ir.cc
+  src/binary-reader-logging.h
   src/binary-reader-logging.cc
+  src/binary-writer.h
   src/binary-writer.cc
+  src/binary-writer-spec.h
   src/binary-writer-spec.cc
+  src/binding-hash.h
   src/binding-hash.cc
+  src/color.h
   src/color.cc
+  src/common.h
   src/common.cc
+  src/config.h
   src/config.cc
+  src/decompiler.h
+  src/decompiler.cc
+  src/error-formatter.h
   src/error-formatter.cc
+  src/expr-visitor.h
   src/expr-visitor.cc
+  src/feature.h
   src/feature.cc
+  src/filenames.h
   src/filenames.cc
+  src/generate-names.h
   src/generate-names.cc
+  src/hash-util.h
   src/hash-util.cc
+  src/ir.h
   src/ir.cc
+  src/ir-util.h
+  src/ir-util.cc
+  src/leb128.h
   src/leb128.cc
+  src/lexer-source.h
   src/lexer-source.cc
+  src/lexer-source-line-finder.h
   src/lexer-source-line-finder.cc
+  src/literal.h
   src/literal.cc
+  src/opcode.h
   src/opcode.cc
+  src/opcode-code-table.h
   src/opcode-code-table.c
+  src/opcode.def
+  src/option-parser.h
   src/option-parser.cc
+  src/resolve-names.h
   src/resolve-names.cc
+  src/stream.h
   src/stream.cc
+  src/string-view.h
   src/string-view.cc
+  src/token.h
   src/token.cc
+  src/tracing.h
   src/tracing.cc
+  src/type-checker.h
   src/type-checker.cc
+  src/utf8.h
   src/utf8.cc
+  src/validator.h
   src/validator.cc
+  src/wast-lexer.h
   src/wast-lexer.cc
+  src/wast-parser.h
   src/wast-parser.cc
+  src/wat-writer.h
   src/wat-writer.cc
 
   # TODO(binji): Move this into its own library?
+  src/interp/binary-reader-interp.h
   src/interp/binary-reader-interp.cc
+  src/interp/interp.h
   src/interp/interp.cc
   src/interp/interp-disassemble.cc
   src/interp/interp-trace.cc
@@ -369,58 +414,23 @@
       SOURCES src/tools/wasm-strip.cc
       INSTALL
     )
+
+    if (WIP_TOOLS)
+      # wasm-decompile
+      wabt_executable(
+        NAME wasm-decompile
+        SOURCES src/tools/wasm-decompile.cc
+        INSTALL
+      )
+    endif()
   endif ()
 
   find_package(Threads)
   if (BUILD_TESTS)
-    if (NOT EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/third_party/gtest/googletest)
-      message(FATAL_ERROR "Can't find third_party/gtest. Run git submodule update --init, or disable with CMake -DBUILD_TESTS=OFF.")
-    endif ()
-
-    include_directories(
-      third_party/gtest/googletest
-      third_party/gtest/googletest/include
-    )
-
-    # gtest
-    add_library(libgtest STATIC
-      third_party/gtest/googletest/src/gtest-all.cc
-    )
-
-    # hexfloat-test
-    set(HEXFLOAT_TEST_SRCS
-      src/literal.cc
-      src/test-hexfloat.cc
-      third_party/gtest/googletest/src/gtest_main.cc
-    )
-    wabt_executable(
-      NAME hexfloat_test
-      SOURCES ${HEXFLOAT_TEST_SRCS}
-      LIBS libgtest ${CMAKE_THREAD_LIBS_INIT}
-    )
-
-    # wabt-unittests
-    set(UNITTESTS_SRCS
-      src/test-binary-reader.cc
-      src/test-circular-array.cc
-      src/test-interp.cc
-      src/test-intrusive-list.cc
-      src/test-literal.cc
-      src/test-string-view.cc
-      src/test-filenames.cc
-      src/test-utf8.cc
-      src/test-wast-parser.cc
-      third_party/gtest/googletest/src/gtest_main.cc
-    )
-    wabt_executable(
-      NAME wabt-unittests
-      SOURCES ${UNITTESTS_SRCS}
-      LIBS libgtest ${CMAKE_THREAD_LIBS_INIT}
-    )
-
-    if (NOT CMAKE_VERSION VERSION_LESS "3.2")
-      set(USES_TERMINAL USES_TERMINAL)
-    endif ()
-
-    # test running
-    find_package(PythonInterp 2.7 REQUIRED)
+    if (NOT USE_SYSTEM_GTEST)
+      if (NOT EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/third_party/gtest/googletest)
+        message(FATAL_ERROR "Can't find third_party/gtest. Run git submodule update --init, or disable with CMake -DBUILD_TESTS=OFF.")
+      endif ()
+
+      include_directories(
+        third_party/gtest/googletest

=== Makefile ===
--- 
+++ 
@@ -23,7 +23,7 @@
 FUZZ_BIN_DIR ?= ${ROOT_DIR}/afl-fuzz
 GCC_FUZZ_CC := ${FUZZ_BIN_DIR}/afl-gcc
 GCC_FUZZ_CXX := ${FUZZ_BIN_DIR}/afl-g++
-EMSCRIPTEN_DIR ?= ${ROOT_DIR}/emscripten
+EMSCRIPTEN_DIR ?= $(dir $(shell which emcc))
 CMAKE_CMD ?= cmake
 
 DEFAULT_SUFFIX = clang-debug

=== debian/changelog ===
wabt (1.0.12-1) unstable; urgency=medium

  * New upstream version 1.0.12.
  * Build-depend on python3 instead of python. (Closes: #938805)

 -- Markus Koschany <apo@debian.org>  Sun, 29 Sep 2019 17:46:08 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends:
  cmake,
  debhelper-compat (= 12),
- python,
+ python3,
  re2c
 Standards-Version: 4.4.0
 Homepage: https://github.com/WebAssembly/wabt

## wabt 1.0.13

=== CMakeLists.txt ===
--- 
+++ 
@@ -17,6 +17,8 @@
 cmake_minimum_required(VERSION 2.6)
 project(WABT)
 
+set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
+
 option(BUILD_TESTS "Build GTest-based tests" ON)
 option(USE_SYSTEM_GTEST "Use system GTest, instead of building" OFF)
 option(BUILD_TOOLS "Build wabt commandline tools" ON)
@@ -27,9 +29,12 @@
 option(CODE_COVERAGE "Build with code coverage enabled" OFF)
 option(WITH_EXCEPTIONS "Build with exceptions enabled" OFF)
 option(WERROR "Build with warnings as errors" OFF)
-option(WIP_TOOLS "Build Work-In-Progress functionality" OFF)
-
-if (CMAKE_C_COMPILER_ID MATCHES "Clang")
+
+if (MSVC)
+  set(COMPILER_IS_CLANG 0)
+  set(COMPILER_IS_GNU 0)
+  set(COMPILER_IS_MSVC 1)
+elseif (CMAKE_C_COMPILER_ID MATCHES "Clang")
   set(COMPILER_IS_CLANG 1)
   set(COMPILER_IS_GNU 0)
   set(COMPILER_IS_MSVC 0)
@@ -37,10 +42,6 @@
   set(COMPILER_IS_CLANG 0)
   set(COMPILER_IS_GNU 1)
   set(COMPILER_IS_MSVC 0)
-elseif (MSVC)
-  set(COMPILER_IS_CLANG 0)
-  set(COMPILER_IS_GNU 0)
-  set(COMPILER_IS_MSVC 1)
 elseif (CMAKE_SYSTEM_NAME STREQUAL "Emscripten")
   set(COMPILER_IS_CLANG 1)
   set(COMPILER_IS_GNU 0)
@@ -68,6 +69,22 @@
 check_type_size(ssize_t SSIZE_T)
 check_type_size(size_t SIZEOF_SIZE_T)
 
+FIND_PACKAGE(Git QUIET REQUIRED)
+EXECUTE_PROCESS(COMMAND
+        "${GIT_EXECUTABLE}" --git-dir=${CMAKE_CURRENT_SOURCE_DIR}/.git describe --tags
+        RESULT_VARIABLE
+            GIT_HASH_RESULT
+        OUTPUT_VARIABLE
+            GIT_HASH
+        OUTPUT_STRIP_TRAILING_WHITESPACE)
+
+IF(${GIT_HASH_RESULT} EQUAL 0)
+    SET(WABT_VERSION_INFO "${GIT_HASH}")
+ELSE()
+    MESSAGE(WARNING "Error running git describe to determine version")
+    SET(WABT_VERSION_INFO "(unable to determine version)")
+ENDIF()
+
 configure_file(
   ${WABT_SOURCE_DIR}/src/config.h.in
   ${WABT_BINARY_DIR}/config.h
@@ -107,7 +124,7 @@
   endif ()
 
   if (NOT WITH_EXCEPTIONS)
-    add_definitions(-fno-exceptions)
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-exceptions")
   endif ()
 
   # Need to define __STDC_*_MACROS because C99 specifies that C++ shouldn't
@@ -171,7 +188,7 @@
 
 set(USE_SANITIZER FALSE)
 
-function(SANITIZER NAME FLAGS)
+function(sanitizer NAME FLAGS)
   if (${NAME})
     if (USE_SANITIZER)
       message(FATAL_ERROR "Only one sanitizer allowed")
@@ -181,22 +198,22 @@
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${FLAGS}" PARENT_SCOPE)
   endif ()
 endfunction()
-SANITIZER(USE_ASAN "-fsanitize=address")
-SANITIZER(USE_MSAN "-fsanitize=memory")
-SANITIZER(USE_LSAN "-fsanitize=leak")
+sanitizer(USE_ASAN "-fsanitize=address")
+sanitizer(USE_MSAN "-fsanitize=memory")
+sanitizer(USE_LSAN "-fsanitize=leak")
 
 if (USE_UBSAN)
   # -fno-sanitize-recover was deprecated, see if we are compiling with a newer
   # clang that requires -fno-sanitize-recover=all.
   set(UBSAN_BLACKLIST ${WABT_SOURCE_DIR}/ubsan.blacklist)
   include(CheckCXXCompilerFlag)
-  CHECK_CXX_COMPILER_FLAG("-fsanitize=undefined -fno-sanitize-recover -Wall -Werror" HAS_UBSAN_RECOVER_BARE)
+  check_cxx_compiler_flag("-fsanitize=undefined -fno-sanitize-recover -Wall -Werror" HAS_UBSAN_RECOVER_BARE)
   if (HAS_UBSAN_RECOVER_BARE)
-    SANITIZER(USE_UBSAN "-fsanitize=undefined -fno-sanitize-recover -fsanitize-blacklist=${UBSAN_BLACKLIST}")
-  endif ()
-  CHECK_CXX_COMPILER_FLAG("-fsanitize=undefined -fno-sanitize-recover=all -Wall -Werror" HAS_UBSAN_RECOVER_ALL)
+    sanitizer(USE_UBSAN "-fsanitize=undefined -fno-sanitize-recover -fsanitize-blacklist=${UBSAN_BLACKLIST}")
+  endif ()
+  check_cxx_compiler_flag("-fsanitize=undefined -fno-sanitize-recover=all -Wall -Werror" HAS_UBSAN_RECOVER_ALL)
   if (HAS_UBSAN_RECOVER_ALL)
-    SANITIZER(USE_UBSAN "-fsanitize=undefined -fno-sanitize-recover=all -fsanitize-blacklist=${UBSAN_BLACKLIST}")
+    sanitizer(USE_UBSAN "-fsanitize=undefined -fno-sanitize-recover=all -fsanitize-blacklist=${UBSAN_BLACKLIST}")
   endif ()
   if (NOT USE_SANITIZER)
     message(FATAL_ERROR "UBSAN is not supported")
@@ -207,7 +224,7 @@
 
 add_custom_target(everything)
 
-add_library(wabt STATIC
+set(WABT_LIBRARY_SRC
   src/apply-names.h
   src/apply-names.cc
   src/binary.h
@@ -231,6 +248,9 @@
   src/config.h
   src/config.cc
   src/decompiler.h
+  src/decompiler-ast.h
+  src/decompiler-ls.h
+  src/decompiler-naming.h
   src/decompiler.cc
   src/error-formatter.h
   src/error-formatter.cc
@@ -260,7 +280,6 @@
   src/opcode.cc
   src/opcode-code-table.h
   src/opcode-code-table.c
-  src/opcode.def
   src/option-parser.h
   src/option-parser.cc
   src/resolve-names.h
@@ -289,12 +308,27 @@
   # TODO(binji): Move this into its own library?
   src/interp/binary-reader-interp.h
   src/interp/binary-reader-interp.cc
+  src/interp/binary-reader-metadata.h
+  src/interp/binary-reader-metadata.cc
   src/interp/interp.h
   src/interp/interp.cc
   src/interp/interp-disassemble.cc
   src/interp/interp-trace.cc
 )
 
+add_library(wabt STATIC ${WABT_LIBRARY_SRC})
+
+# libwasm, which implenents the wasm C API
+add_library(wasm SHARED ${WABT_LIBRARY_SRC} src/interp/interp-wasm-c-api.cc)
+target_link_libraries(wasm wabt)
+target_include_directories(wasm PUBLIC third_party/wasm-c-api/include)
+if (COMPILER_IS_MSVC)
+  target_compile_definitions(wasm PRIVATE "WASM_API_EXTERN=__declspec(dllexport)")
+else ()
+  target_compile_options(wasm PRIVATE -Wno-old-style-cast)
+  target_compile_definitions(wasm PRIVATE "WASM_API_EXTERN=__attribute__((visibility(\"default\")))")
+endif ()
+set_target_properties(wasm PROPERTIES CXX_VISIBILITY_PRESET hidden)
 
 if (NOT EMSCRIPTEN)
   if (CODE_COVERAGE)
@@ -374,63 +408,3 @@
     # wasm-objdump
     wabt_executable(
       NAME wasm-objdump
-      SOURCES src/tools/wasm-objdump.cc src/binary-reader-objdump.cc
-      INSTALL
-    )
-
-    # wasm-interp
-    wabt_executable(
-      NAME wasm-interp
-      SOURCES src/tools/wasm-interp.cc
-      WITH_LIBM
-      INSTALL
-    )
-
-    # spectest-interp
-    wabt_executable(
-      NAME spectest-interp
-      SOURCES src/tools/spectest-interp.cc
-      WITH_LIBM
-      INSTALL
-    )
-
-    # wat-desugar
-    wabt_executable(
-      NAME wat-desugar
-      SOURCES src/tools/wat-desugar.cc
-      INSTALL
-    )
-
-    # wasm-validate
-    wabt_executable(
-      NAME wasm-validate
-      SOURCES src/tools/wasm-validate.cc
-      INSTALL
-    )
-
-    # wasm-strip
-    wabt_executable(
-      NAME wasm-strip
-      SOURCES src/tools/wasm-strip.cc
-      INSTALL
-    )
-
-    if (WIP_TOOLS)
-      # wasm-decompile
-      wabt_executable(
-        NAME wasm-decompile
-        SOURCES src/tools/wasm-decompile.cc
-        INSTALL
-      )
-    endif()
-  endif ()
-
-  find_package(Threads)
-  if (BUILD_TESTS)
-    if (NOT USE_SYSTEM_GTEST)
-      if (NOT EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/third_party/gtest/googletest)
-        message(FATAL_ERROR "Can't find third_party/gtest. Run git submodule update --init, or disable with CMake -DBUILD_TESTS=OFF.")
-      endif ()
-
-      include_directories(
-        third_party/gtest/googletest

=== Makefile ===
--- 
+++ 
@@ -28,7 +28,7 @@
 
 DEFAULT_SUFFIX = clang-debug
 
-COMPILERS := GCC GCC_I686 GCC_FUZZ CLANG EMCC
+COMPILERS := GCC GCC_I686 GCC_FUZZ CLANG CLANG_I686 EMCC
 BUILD_TYPES := DEBUG RELEASE
 SANITIZERS := ASAN MSAN LSAN UBSAN
 CONFIGS := NORMAL $(SANITIZERS) COV NO_TESTS
@@ -38,6 +38,7 @@
 GCC_I686_DIR := gcc-i686/
 GCC_FUZZ_DIR := gcc-fuzz/
 CLANG_DIR := clang/
+CLANG_I686_DIR := clang-i686/
 EMCC_DIR := emscripten/
 DEBUG_DIR := Debug/
 RELEASE_DIR := Release/
@@ -55,6 +56,8 @@
 	-DCMAKE_C_FLAGS=-m32 -DCMAKE_CXX_FLAGS=-m32
 GCC_FUZZ_FLAG := -DCMAKE_C_COMPILER=${GCC_FUZZ_CC} -DCMAKE_CXX_COMPILER=${GCC_FUZZ_CXX} -DWITH_EXCEPTIONS=ON
 CLANG_FLAG := -DCMAKE_C_COMPILER=clang -DCMAKE_CXX_COMPILER=clang++
+CLANG_I686_FLAG := -DCMAKE_C_COMPILER=clang -DCMAKE_CXX_COMPILER=clang++ \
+	-DCMAKE_C_FLAGS=-m32 -DCMAKE_CXX_FLAGS=-m32
 EMCC_FLAG := -DCMAKE_TOOLCHAIN_FILE=${EMSCRIPTEN_DIR}/cmake/Modules/Platform/Emscripten.cmake
 DEBUG_FLAG := -DCMAKE_BUILD_TYPE=Debug
 RELEASE_FLAG := -DCMAKE_BUILD_TYPE=Release
@@ -71,6 +74,7 @@
 GCC_I686_PREFIX := gcc-i686
 GCC_FUZZ_PREFIX := gcc-fuzz
 CLANG_PREFIX := clang
+CLANG_I686_PREFIX := clang-i686
 EMCC_PREFIX := emscripten
 DEBUG_PREFIX := -debug
 RELEASE_PREFIX := -release
@@ -121,7 +125,7 @@
 define TEST
 .PHONY: $(call TEST_TARGET,$(1),$(2),$(3))
 $(call TEST_TARGET,$(1),$(2),$(3)): $(call CMAKE_DIR,$(1),$(2),$(3))$$(BUILD_FILE)
-	$$(BUILD_CMD) -C $(call CMAKE_DIR,$(1),$(2),$(3)) run-tests
+	$$(BUILD_CMD) -C $(call CMAKE_DIR,$(1),$(2),$(3)) check
 test-everything: $(CALL TEST_TARGET,$(1),$(2),$(3))
 endef

=== debian/changelog ===
wabt (1.0.13-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:28:34 +0100

wabt (1.0.13-1) unstable; urgency=medium

  * New upstream version 1.0.13.
  * Declare compliance with Debian Policy 4.5.0.
  * Add two patches to not require Git for building wabt and to accommodate
    the missing wasm.h file.

 -- Markus Koschany <apo@debian.org>  Thu, 23 Jan 2020 22:58:51 +0100

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
  debhelper-compat (= 12),
  python3,
  re2c
-Standards-Version: 4.4.0
+Standards-Version: 4.5.0
 Homepage: https://github.com/WebAssembly/wabt
 Vcs-Git: https://salsa.debian.org/debian/wabt.git
 Vcs-Browser: https://salsa.debian.org/debian/wabt

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/wabt-$1\.tar\.gz/ \
  https://github.com/WebAssembly/wabt/tags .*/v?(\d\S+)\.tar\.gz

## wabt 1.0.15

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,10 +14,27 @@
 # limitations under the License.
 #
 
-cmake_minimum_required(VERSION 2.6)
-project(WABT)
+cmake_minimum_required(VERSION 3.0.0)
+project(WABT VERSION 1.0.13)
 
 set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
+
+# For git users, attempt to generate a more useful version string
+if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/.git)
+  find_package(Git QUIET REQUIRED)
+  execute_process(COMMAND
+          "${GIT_EXECUTABLE}" --git-dir=${CMAKE_CURRENT_SOURCE_DIR}/.git describe --tags
+          RESULT_VARIABLE
+              GIT_VERSION_RESULT
+          OUTPUT_VARIABLE
+              GIT_VERSION
+          OUTPUT_STRIP_TRAILING_WHITESPACE)
+  if (${GIT_VERSION_RESULT})
+    message(WARNING "Error running git describe to determine version")
+  else ()
+    set(CMAKE_PROJECT_VERSION "${CMAKE_PROJECT_VERSION} (${GIT_VERSION})")
+  endif ()
+endif ()
 
 option(BUILD_TESTS "Build GTest-based tests" ON)
 option(USE_SYSTEM_GTEST "Use system GTest, instead of building" OFF)
@@ -58,7 +75,6 @@
 check_include_file("alloca.h" HAVE_ALLOCA_H)
 check_include_file("unistd.h" HAVE_UNISTD_H)
 check_symbol_exists(snprintf "stdio.h" HAVE_SNPRINTF)
-check_symbol_exists(sysconf "unistd.h" HAVE_SYSCONF)
 check_symbol_exists(strcasecmp "strings.h" HAVE_STRCASECMP)
 
 if (WIN32)
@@ -68,22 +84,6 @@
 include(CheckTypeSize)
 check_type_size(ssize_t SSIZE_T)
 check_type_size(size_t SIZEOF_SIZE_T)
-
-FIND_PACKAGE(Git QUIET REQUIRED)
-EXECUTE_PROCESS(COMMAND
-        "${GIT_EXECUTABLE}" --git-dir=${CMAKE_CURRENT_SOURCE_DIR}/.git describe --tags
-        RESULT_VARIABLE
-            GIT_HASH_RESULT
-        OUTPUT_VARIABLE
-            GIT_HASH
-        OUTPUT_STRIP_TRAILING_WHITESPACE)
-
-IF(${GIT_HASH_RESULT} EQUAL 0)
-    SET(WABT_VERSION_INFO "${GIT_HASH}")
-ELSE()
-    MESSAGE(WARNING "Error running git describe to determine version")
-    SET(WABT_VERSION_INFO "(unable to determine version)")
-ENDIF()
 
 configure_file(
   ${WABT_SOURCE_DIR}/src/config.h.in
@@ -117,6 +117,7 @@
     -Wuninitialized
   )
 
+  set(CMAKE_CXX_EXTENSIONS OFF)
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Wold-style-cast")
 
   if (WERROR)
@@ -132,11 +133,11 @@
   # definition, and some libcs (e.g. glibc2.17 and earlier) follow that.
   add_definitions(-D__STDC_LIMIT_MACROS=1 -D__STDC_FORMAT_MACROS=1)
 
-  if (MINGW)
-    # _POSIX is needed to ensure we use mingw printf
+  if (MINGW OR CYGWIN)
+    # On MINGW, _POSIX_C_SOURCE is needed to ensure we use mingw printf
     # instead of the VC runtime one.
-    add_definitions(-D_POSIX)
-  endif ()
+    add_definitions(-D_POSIX_C_SOURCE=200809L)
+  endif()
 
   if (COMPILER_IS_GNU)
     # disable -Wclobbered: it seems to be guessing incorrectly about a local
@@ -284,6 +285,8 @@
   src/option-parser.cc
   src/resolve-names.h
   src/resolve-names.cc
+  src/shared-validator.h
+  src/shared-validator.cc
   src/stream.h
   src/stream.cc
   src/string-view.h
@@ -292,6 +295,7 @@
   src/token.cc
   src/tracing.h
   src/tracing.cc
+  src/type.h
   src/type-checker.h
   src/type-checker.cc
   src/utf8.h
@@ -308,12 +312,14 @@
   # TODO(binji): Move this into its own library?
   src/interp/binary-reader-interp.h
   src/interp/binary-reader-interp.cc
-  src/interp/binary-reader-metadata.h
-  src/interp/binary-reader-metadata.cc
   src/interp/interp.h
   src/interp/interp.cc
-  src/interp/interp-disassemble.cc
-  src/interp/interp-trace.cc
+  src/interp/interp-inl.h
+  src/interp/interp-math.h
+  src/interp/interp-util.h
+  src/interp/interp-util.cc
+  src/interp/istream.h
+  src/interp/istream.cc
 )
 
 add_library(wabt STATIC ${WABT_LIBRARY_SRC})
@@ -340,6 +346,7 @@
     endif ()
   endif ()
 
+  include(CMakeParseArguments)
   function(wabt_executable)
     cmake_parse_arguments(EXE "WITH_LIBM;INSTALL" "NAME" "SOURCES;LIBS" ${ARGN})
 
@@ -396,15 +403,3 @@
       NAME wasm2c
       SOURCES src/tools/wasm2c.cc src/c-writer.cc
       INSTALL
-    )
-
-    # wasm-opcodecnt
-    wabt_executable(
-      NAME wasm-opcodecnt
-      SOURCES src/tools/wasm-opcodecnt.cc src/binary-reader-opcnt.cc
-      INSTALL
-    )
-
-    # wasm-objdump
-    wabt_executable(
-      NAME wasm-objdump

=== debian/changelog ===
wabt (1.0.15-1) unstable; urgency=medium

  * New upstream version 1.0.15.
  * Switch to debhelper-compat = 13

 -- Markus Koschany <apo@debian.org>  Tue, 12 May 2020 00:41:09 +0200
